#-*- coding: utf-8 -*-
from Components.config import config, configfile
from enigma import eTimer
from Tools.Directories import fileExists, resolveFilename, SCOPE_PLUGINS
from twisted.web.client import downloadPage, getPage, error
from twisted.internet import defer, task, reactor, threads
import codecs
import datetime, time
import os
import sys

# new
import json
#import urllib2

import ssl
try:
	_create_unverified_https_context = ssl._create_unverified_context
except AttributeError:
	# Legacy Python that doesn't verify HTTPS certificates by default
	pass
else:
	# Handle target environment that doesn't support HTTPS verification
	ssl._create_default_https_context = _create_unverified_https_context

# our custom classes
from .SkyRunAutocheck import SkyRunAutocheck
from .SkyTheMovieDB import SkyTheMovieDB
from .SkyMainFunctions import requestPage, nonHDeventList, buildSkyChannellist, decodeHtml, getHttpHeader, getHttpHeader1, getUserAgent, getHttpHeader2, getEventAllowedRange, getDayOfTheWeek, getDateFromTimestamp, getCurrentTimestamp, getHttpHeaderJSON, checkForInternet, setWecker
from .SkySql import *
from Tools.BoundFunction import boundFunction

class SkyGetTvGuide():

	def __init__(self, session, oneShot = False, no_after_event = None):

		# singleton class - needed to call it at sessionstart
		SkyGetTvGuide.instance = self

		self.session = session
		self.oneShot = oneShot
		self.no_after_event = no_after_event
		self.pluginName = config.plugins.skyrecorder.pluginname.value
		self.IS_RUNNING = False

		# init statistics
		self.statEventsTotal = 0
		self.statEventsRequested = 0
		self.statEventsSkipped = 0
		self.statEventsSkipped500 = 0
		self.statEventsSkippedLate = 0
		self.statErrors = 0

		#self.nonHDeventList = nonHDeventList()
		#self.sky_chlist = buildSkyChannellist()

		#### Diese Header-Daten lassen die Daten-Abfragen so aussehen, als wenn sie von der Sky-Webseite kommen  ##  Tarnung ist Alles!  ##
		#self.agent = getUserAgent()
		#self.agent = "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:89.0) Gecko/20100101 Firefox/89.0"
		#self.agent = "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/91.0.4472.114 Safari/537.36 Edg/91.0.864.59"
		self.agent = b'python-requests/2.25.1'
		host_agent = {b"Host": b"www.sky.de", b"User-Agent": self.agent}
		standard_headers = {b"Accept-Language": b"de,en-US;q=0.7,en;q=0.3", b"DNT": b"1",}  #"Accept-Encoding": "gzip, deflate, br",	#"Connection": "keep-alive", #"Cache-Control": "no-cache", #"Pragma": "no-cache",}
		self.headersTvGuide = host_agent  #getHttpHeader1()
		self.headersTvGuide.update(host_agent)
		self.headersTvGuide.update({b"Accept": b"text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8", b"Upgrade-Insecure-Requests": b"1",})
		self.headersTvGuide.update(standard_headers)
		self.headersJSON = host_agent  #getHttpHeaderJSON()
		self.headersJSON.update(host_agent)
		self.headersJSON.update({b"Origin": b"https://www.sky.de", b"Referer": b"https://www.sky.de/tvguide-7599"})
		self.headersJSON.update({b"Accept": b"application/json, text/javascript, */*; q=0.01", b"TE": b"Trailers", b"Content-Type": b"application/json", b"X-Requested-With": b"XMLHttpRequest",})
		self.headersJSON.update(standard_headers)

		self.ck = {}
		try:
			self.sky_log_path = config.plugins.skyrecorder.skylog.value
		except:
			self.sky_log_path = "/usr/lib/enigma2/python/Plugins/Extensions/skyrecorder/sky_log"
		if not os.path.isfile(self.sky_log_path):
			file = codecs.open(self.sky_log_path, "w", "utf-8")
			file.write('\xef\xbb\xbf')
			file.close()

		if self.oneShot and config.plugins.skyrecorder.autoupdate_database.value:
		
			# do we really need a new update right now?
			checktime = getCurrentTimestamp()
			nextcheck = checktime
			lastcheck = checktime
			try:
				lastcheck = int(config.plugins.skyrecorder.lastchecked.value)
				nextcheck = int(config.plugins.skyrecorder.next_update.value)
			except Exception:
				#sys.exc_clear()
				pass

			if ((checktime + 300) >= nextcheck) and (lastcheck < nextcheck): # 5 minutes buffer should be ok, because the STB is starting to fast, sometimes
				print("[skyrecorder] timer AutotimerCheck gesetzt")
				
				# be sure we got a new timestamp, even something went wrong
				config.plugins.skyrecorder.lastchecked.value = checktime
				config.plugins.skyrecorder.lastchecked.save()
				# set new wecker for our timer
				if config.plugins.skyrecorder.database_update_time and config.plugins.skyrecorder.database_update_time.value:
					alarm = setWecker(config.plugins.skyrecorder.database_update_time.value, True)  # be sure we shift one day
				else:
					alarm = setWecker([6, 0], True)  # be sure we shift one day
				config.plugins.skyrecorder.next_update.value = alarm
				config.plugins.skyrecorder.next_update.save()
				configfile.save()
				
				# let us start it right now. needed for wakMeUp function
				self.tempTimer = None
				self.tempTimer = eTimer()
				if not os.path.exists("/var/lib/dpkg/status"):                   
					self.tempTimer.callback.append(self.start(self.oneShot))
				else:
					self.tempTimer_conn=self.tempTimer.timeout.connect(boundFunction(self.start, self.oneShot))
				self.tempTimer.start(5000, True)  # give us some time to breath, before we start

		# set the timer for the next update now
		if config.plugins.skyrecorder.autoupdate_database.value:
			self.refreshTimer = None
			self.refreshTimer = eTimer()
			if not os.path.exists("/var/lib/dpkg/status"):                   
				self.refreshTimer.callback.append(self.start)
			else:                                       
				self.refreshTimer_conn=self.refreshTimer.timeout.connect(self.start)
			if config.plugins.skyrecorder.next_update and config.plugins.skyrecorder.lastchecked:
				interval = int(config.plugins.skyrecorder.next_update.value) - getCurrentTimestamp()
				if interval > 60 and interval <= 5184000:  # 60 seconds buffer, but lower or equal than 1 day
					#self.timerinterval = interval * 1000 # milliseconds
					#self.refreshTimer.start(self.timerinterval)
					self.timerinterval = interval
					self.refreshTimer.startLongTimer(self.timerinterval)


	def start(self, oneShot=False, no_after_event=None):
		self.oneShot = oneShot
		self.no_after_event = no_after_event
		
		if not checkForInternet():
			self.error_print_log("no internet, no update... bye")
			return
		
		# update refresh timerinterval now
		if config.plugins.skyrecorder.autoupdate_database.value:
			try:
				if self.refreshTimer:
					if config.plugins.skyrecorder.database_update_time and config.plugins.skyrecorder.database_update_time.value:
						alarm = setWecker(config.plugins.skyrecorder.database_update_time.value, True) # be sure we shift one day
					else:
						alarm = setWecker([6,0], True) # be sure we shift one day
					config.plugins.skyrecorder.next_update.value = alarm
					config.plugins.skyrecorder.next_update.save()
					configfile.save()
					
					interval = int(config.plugins.skyrecorder.next_update.value) - getCurrentTimestamp()
					self.refreshTimer.stop()
					self.refreshTimer.startLongTimer(interval)
					self.debug_print_log('refreshTimer restarted')
			except Exception:
				self.error_print_log("Could not restart refreshTimer!")

		if self.oneShot or config.plugins.skyrecorder.autoupdate_database.value:
			self.IS_RUNNING = True
			self.info_print_log("aktualisiere Datenbank...")

			try:
				sql.cur.execute('SELECT SQLITE_VERSION()')
			except Exception:
				#sys.exc_clear()
				try:
					sql.connect()
				except Exception:
					self.IS_RUNNING = False
					self.error_print_log("Could not connect to SQLITE!")
					return
			
			# first clean up old files
			self.info_print_log("entferne alte Eintraege...")

			n = sql.deleteEvents(getCurrentTimestamp())
			if n == 1:
				msg_log = "{0} Eintrag geloescht".format(n)
			else:
				msg_log = "{0} Eintraege geloescht".format(n)
			self.info_print_log(msg_log)
			
			# cleanup TMDb
			self.info_print_log("inaktive TMDb-Daten loeschen...")
			sql.cleanupTMDbData(True)
			
			try:
				sql.cur.execute('SELECT SQLITE_VERSION()')
			except Exception:
				#sys.exc_clear()
				try:
					sql.connect()
				except Exception:
					self.IS_RUNNING = False
					self.error_print_log("Could not connect to SQLITE!")
					return
			
			#self.station_id = -1
			#self.last_station_idx = 0
			#self.SkyStations = self.getSkyStations()
			#self.maxStationLoop = len(self.SkyStations) - 1

			# start here
			try:
				self.getTVGuideCookies()
			except Exception as e:
				self.IS_RUNNING = False
				self.error_print_log("getTVGuideCookies: {0}".format(e))


	def stopRun(self):
		self.IS_RUNNING = False
		self.info_print_log("Aktualisierung abgebrochen!")


	def getTVGuideCookies(self):
		url = 'https://www.sky.de/tvguide-7599'
		self.info_print_log("get: '{0}'".format(url))
		try:
			d = requestPage('GET', url, headers=self.headersTvGuide, timeout=30, cookies=self.ck)
		except:
			url = url.encode('utf-8')
			d = getPage(url, headers=self.headersTvGuide, agent=self.agent, timeout=30, cookies=self.ck)
		d.addCallback(self.getSkyChannelList).addErrback(self.dataError, "getTVGuideCookies", self.stopRun)


	def getSkyChannelList(self, data=None):
		url = 'https://www.sky.de/sgtvg/service/getChannelList'
		datas = '{"dom":"de","s":2,"cat":"","cpck":false,"fav":false,"feed":true,"pck":""}'
		self.info_print_log("get: '{0}'".format(url))
		try:
			d = requestPage('POST', url, headers=self.headersJSON, timeout=30, data=datas)
		except:
			url = url.encode('utf-8')
			datas = datas.encode('utf-8')
			d = getPage(url, headers=self.headersJSON, agent=self.agent, timeout=30, method=b'POST', postdata=datas)
		d.addCallback(self.currentSkyChannelList).addErrback(self.dataError, "getSkyChannelList", self.stopRun)


	def currentSkyChannelList(self, data=None):
		sky_channels = json.loads(data)
		if not sky_channels:
			self.IS_RUNNING = False
			self.error_print_log("could not fetch SkyChannelList")
			return
		
		self.SKY_CHANNEL_LIST = {}
		self.NEW_CHANNELS = ""
		self.CHANGED_CHANNELS = ""

		channels = sky_channels.get('cl', None)
		if channels is not None:
			for channel in channels:
				channel_id_sky = int(channel["ci"])
				channel_name = str(channel["cn"])
				self.SKY_CHANNEL_LIST.update({channel_id_sky: channel_name})
				# check if channel needs to be added to database
				existBySkyId = sql.existChannelBySkyId(channel_id_sky)
				if existBySkyId:
					# check if channel name has changed
					old_channel_name = sql.updateChannelName(channel_id_sky, channel_name)
					if old_channel_name:
						if self.CHANGED_CHANNELS != "":
							self.CHANGED_CHANNELS += ', '
						self.CHANGED_CHANNELS += "'{0}' -> '{1}'".format(old_channel_name, channel_name)
						self.info_print_log("channel name changed: '{0}' -> '{1}'".format(old_channel_name, channel_name))
				else:  # not existBySkyId
					self.info_print_log("found new channel: '{0}'".format(channel_name))
					# if (str(channel["cn"]) == "Universal Channel HD"):
					# 	stb_channel_name = "Universal HD"
					# elif (str(channel["cn"]) == "Discovery Channel HD"):
					# 	stb_channel_name = "Discovery HD"
					# elif (str(channel["cn"]) == "E! Entertainment HD"):
					# 	stb_channel_name = "E! Entertainm. HD"
					# elif (str(channel["cn"]) == "History Channel HD"):
					# 	stb_channel_name = "History HD"
					# elif (str(channel["cn"]) == "History Channel"):
					# 	stb_channel_name = "History"
					# elif (str(channel["cn"]) == "National Geographic HD"):
					# 	stb_channel_name = "NatGeo HD"
					# elif (str(channel["cn"]) == "TNT Film"):
					# 	stb_channel_name = "TNT Film HD"
					# elif (str(channel["cn"]) == "National Geopgraphic Wild HD"):
					# 	stb_channel_name = "Nat Geo Wild HD"
					# elif (str(channel["cn"]) == "National Geopgraphic Wild"):
					# 	stb_channel_name = "NatGeo Wild"
					# else:
					stb_channel_name = channel_name

					is_added = sql.addNewChannel(channel_name, stb_channel_name, "False", 0, channel_id_sky)
					if is_added:
						self.info_print_log("channel added to database with status disabled")
						if self.NEW_CHANNELS == "":
							self.NEW_CHANNELS = stb_channel_name
						else:
							self.NEW_CHANNELS = self.NEW_CHANNELS + "," + stb_channel_name
					else:
						self.warn_print_log("could not add channel")
		self.getSkyGuidePages()

		
	def getSkyGuidePages(self):
		self.debug_print_log("building urls")
		
		# settimestamp to preskip outdated events
		# later we will check again with time now()
		self.check_time = getCurrentTimestamp() + 900  #assume our check could takes 15 min
		
		self.is_done = False
		self.pages = []
		self.SKY_GO_BASE = "https://www.sky.de"

		# We want active channles only, or the full list?
		only_active = config.plugins.skyrecorder.only_active_channels and config.plugins.skyrecorder.only_active_channels.value
		channelid_list_sky = sql.getChannelIdSky(only_active)
		self.SEARCH_CHANNEL_IDS = ','.join(str(i) for i in channelid_list_sky)

		if not self.SEARCH_CHANNEL_IDS or len(self.SEARCH_CHANNEL_IDS) < 1:
			self.IS_RUNNING = False
			self.checkDone("keine Sender aktiviert", set_stamp=True)
			return
		
		# actual the TV Guide contains 13 days into the future
		# build day list - we want to scan n-days at once
		self.guide_days_to_search = []
		start_day_offset = 0  # 0 == today, -1 == yesterday
		future_days = 3  # default is 3 days
		if config.plugins.skyrecorder.guide_days_to_scan and config.plugins.skyrecorder.guide_days_to_scan.value:
			future_days = int(config.plugins.skyrecorder.guide_days_to_scan.value)  # max 14 days (2 weeks)

		# include day yesterday in list, but only if we are looking for new broadcasts
		if config.plugins.skyrecorder.only_new_events and config.plugins.skyrecorder.only_new_events.value:
			start_day_offset = -1

		for delta_day in range(start_day_offset, future_days):  # maximum is -1 ... 13 = 15 days = yesterday + 14 days = yesterday + today + 13 days
			self.guide_days_to_search.append(time.mktime((datetime.date.today() + datetime.timedelta(days=delta_day)).timetuple()))

		self.cur_pagenr = 0

		# reset statistics
		self.statEventsTotal = 0
		self.statEventsRequested = 0
		self.statEventsSkipped = 0
		self.statEventsSkipped500 = 0
		self.statEventsSkippedLate = 0
		self.statErrors = 0

		# go
		self.loopGuideDownloadAllDays()
		
		
	def loopGuideDownloadAllDays(self):

		if self.cur_pagenr >= len(self.guide_days_to_search):
			self.tv_guide_list = None
			self.IS_RUNNING = False
			self.checkDone("Datenbank aktualisiert", set_stamp=True)
			return
		else:
			time.sleep(1)  # keep cool, we could download more than one day
			self.tv_guide_list = []

			a_day = self.guide_days_to_search[self.cur_pagenr]
			self.cur_pagenr += 1
			
			my_datas_str = str(int(a_day))+"000"

			urls = []
			urls.append(my_datas_str)
			
			ds = defer.DeferredSemaphore(tokens=1)
			for url in urls:
				ds.run(self.guideDataDownload, url).addCallback(self.guideDataGo).addErrback(self.dataError, "- getBroadcastsForGrid", self.loopGuideDownloadAllDays)


	def guideDataDownload(self, url_data):
		self.info_print_log("Lade Tag {0} von {1}".format(self.cur_pagenr, len(self.guide_days_to_search)))
		url = "https://www.sky.de/sgtvg/service/getBroadcastsForGrid"
		datos = '{"d":' + url_data + ',"cil":[' + self.SEARCH_CHANNEL_IDS + ']}'
		try:
			return requestPage('POST', url, headers=self.headersJSON, timeout=30, data=datos)
		except:
			url = url.encode('utf-8')
			datos = datos.encode('utf-8')
			return getPage(url, headers=self.headersJSON, agent=self.agent, timeout=30, method=b'POST', postdata=datos)


	def guideDataGo(self, data):
		# wait a second
		time.sleep(0.3)

		#data = decodeHtml(data).encode('utf-8')
		info = json.loads(data)
		if not info:
			self.error_print_log("could not get TV-Guide")
			self.IS_RUNNING = False
			return
		#self.debug_print_log("Daten erhalten")
		
		# debug me
		#with open("/tmp/guide_data_base.txt" , "w") as f:
		#	f.write(str(info))

		channel_list = info.get('cl', [])
		cur_channel = 0

		for channel_dict in channel_list:
			
			cur_channel += 1
			
			# try to break, if we want so
			if self.IS_RUNNING == False:
				return

			event_list = channel_dict.get('el', [])
			if len(event_list) == 0:
				continue 

			channel_name = self.SKY_CHANNEL_LIST[int(channel_dict.get('ci', 0))]
			if not channel_name or channel_name == "":
				continue
			id_channel = sql.getIdChannel(channel_name, stb=False)
			if not id_channel:
				self.warn_print_log("channel not found: {0}".format(channel_name))
				continue

			#self.info_print_log("trying channel: {0}".format(channel))
			self.info_print_log("Prüfe Sender {} von {} - {} - {} Sendungen".format(cur_channel, len(channel_list), channel_name, len(event_list)))

			for event_dict in event_list:

				self.statEventsTotal += 1
				
				my_db_dict = {}
				# (default) parameters we need for table 'broadcast'
				my_db_dict["id_genre"] = None  # INTEGER
				my_db_dict["broadcast_id"] = 0  # INTEGER
				my_db_dict["series_id"] = 0  # INTEGER
				my_db_dict["title"] = ""  # TEXT
				my_db_dict["episode_title"] = ""  # TEXT
				my_db_dict["description"] = ""  # TEXT
				my_db_dict["category"] = ""  # TEXT
				my_db_dict["country"] = ""  # TEXT
				my_db_dict["year"] = ""  # TEXT
				my_db_dict["season_no"] = -1  # INTEGER
				my_db_dict["episode_no"] = -1  # INTEGER
				my_db_dict["image"] = ""  # TEXT
				my_db_dict["status"] = "False"  # TEXT
				my_db_dict["new"] = 0  # INTEGER
				my_db_dict["hd"] = 0  # INTEGER
				my_db_dict["dolby"] = 0  # INTEGER
				my_db_dict["dualch"] = 0  # INTEGER
				my_db_dict["highlight"] = 0  # INTEGER
				my_db_dict["live"] = 0  # INTEGER

				# (default) parameters we need for table 'event'
				my_db_dict["id_channel"] = id_channel  # INTEGER
				my_db_dict["event_id"] = 0  # INTEGER
				my_db_dict["datum"] = ""  # TEXT
				my_db_dict["starttime"] = ""  # finally INTEGER
				my_db_dict["endtime"] = ""  # finally INTEGER
				my_db_dict["dayname"] = ""  # TEXT

				title = event_dict.get("et", None)
				if not title or title == "":
					continue
				my_db_dict["title"] = decodeHtml(title).decode('utf-8')

				my_db_dict["episode_title"] = decodeHtml(event_dict.get("epit", "")).decode('utf-8')

				try:
					my_db_dict["season_no"] = int(decodeHtml(event_dict.get("sn", "")).decode('utf-8'))
				except:
					pass

				try:
					my_db_dict["episode_no"] = int(decodeHtml(event_dict.get("en", "")).decode('utf-8'))
				except:
					pass

				my_db_dict["category"] = decodeHtml(event_dict.get("ec", "")).decode('utf-8')
				id_genre = None
				if my_db_dict["category"] != "":
					id_genre = sql.getIdGenre(my_db_dict["category"])
				if not id_genre:
					###### add the new genre to db ?
					add_new_genres = config.plugins.skyrecorder.add_new_genres and config.plugins.skyrecorder.add_new_genres.value
					if my_db_dict["category"] != "" and add_new_genres:
						if my_db_dict["season_no"] >= 0:
							id_groups = 2  # Serie
						else:
							id_groups = 5  # Sonstige
						id_genre = sql.addGenre(my_db_dict["category"], id_groups)
					else:
						id_genre = 49  # 49 = - (Sonstige)
				my_db_dict["id_genre"] = id_genre

				my_db_dict["country"] = decodeHtml(event_dict.get("cop", "")).decode('utf-8')

				my_db_dict["year"] = str(event_dict.get("yop", ""))

				image = event_dict.get('pu', "")
				if image and image != "":
					image = self.SKY_GO_BASE + image
					my_db_dict["image"] = image

				if event_dict.get("new", False):
					my_db_dict["new"] = 1

				# msg_log = "[skyrecorder] NEU: {0} String: {1}".format(is_new,jstring)
				# print(msg_log)
				# self.addLog(msg_log)

				# load only new broadcasts?
				if config.plugins.skyrecorder.only_new_events and config.plugins.skyrecorder.only_new_events.value:
					if my_db_dict["new"] == 0:
						# second check, because only the first broadcast event isNew.
						# But what, if we want the others as well?
						# check if it was new in the past
						check = False
						if self.tv_guide_list and len(self.tv_guide_list) > 0:
							for item in self.tv_guide_list:
								if item["title"] == title \
										and item["episode_title"] == my_db_dict["episode_title"] \
										and item["season_no"] == my_db_dict["season_no"] \
										and item["episode_no"] == my_db_dict["episode_no"] \
										and item["country"] == my_db_dict["country"] \
										and item["year"] == my_db_dict["year"]:
									check = True
						# not in this day dict, but maybe in our database?
						if not check and not sql.existBroadcastIsNew(title, my_db_dict["episode_title"], my_db_dict["season_no"],
																	 my_db_dict["episode_no"], my_db_dict["country"], my_db_dict["year"]):
								continue  # also not new in the past
						# we got an item in our list of dicts - remark the current event as new
						my_db_dict["new"] = 1

				if event_dict.get("isl", False):
					my_db_dict["live"] = 1
				
				if event_dict.get("ish", False):
					my_db_dict["highlight"] = 1

				starttime = event_dict["bst"]
				starttime = str(starttime)
				my_db_dict["starttime"] = starttime
				
				#msg_log = "[skyrecorder] StartZeit {0}".format(starttime)
				#print(msg_log)
				#self.addLog(msg_log)								
				
				sdatum = event_dict["bsdt"]  # startDate = 06.03.2013
				tdatum = datetime.datetime.fromtimestamp(int(sdatum) / 1000)
				datum = tdatum.strftime('%d.%m.%Y')
				my_db_dict["datum"] = datum
				
				#msg_log = "[skyrecorder] Start {0}".format(datum)
				#print(msg_log)
				#self.addLog(msg_log)
				
				sdatum_end = event_dict["bedt"]  # endDate = 07.03.2013
				tdatum_end = datetime.datetime.fromtimestamp(int(sdatum_end) / 1000)
				datum_end = tdatum_end.strftime('%d.%m.%Y')
				my_db_dict["datum_end"] = datum_end
				
				#msg_log = "[skyrecorder] Ende {0}".format(datum_end)
				#print(msg_log)
				#self.addLog(msg_log)
				
				#sendtime = channel_id["el"][n]["endTime"]	## ist nicht im JSON enhalten
				sendtime = event_dict["bedt"]  # endDateTime
				tendtime = datetime.datetime.fromtimestamp(int(sendtime) / 1000)
				endtime = tendtime.strftime("%H:%M")
				my_db_dict["endtime"] = endtime
				
				# check if we can skip this broadcast date
				tstamp_start = self.unixtime(datum, starttime)
				tstamp_end = self.unixtime(datum_end, endtime)
				skytime = self.skyTimeStamp(starttime, tstamp_start, tstamp_end)
				# we will load outdated only if they were new
				if self.check_time > skytime[0] and not my_db_dict["new"]:
					self.statEventsSkipped += 1
					continue
				
				sky_event_id = event_dict.get("ei", 0)
				if not sky_event_id or sky_event_id == 0:
					self.addLog("no sky event id 'ei' found")
					continue
				my_db_dict["event_id"] = sky_event_id
				my_db_dict["details_url"] = str(sky_event_id) + "/" + str(channel_dict["ci"])

				#self.debug_print_log("SkyID + SenderID  {0}".format(my_url))

				if self.canSkipByDB(my_db_dict):
					self.statEventsSkipped += 1
					continue

				if self.canSkipByError500(my_db_dict):
					self.statEventsSkipped500 += 1
					continue

				# update our guide list
				self.tv_guide_list.append(my_db_dict)
				
				try:
					del(my_db_dict)
				except Exception:
					#sys.exc_clear()
					pass
		
		# now get the event details
		if self.tv_guide_list and len(self.tv_guide_list) > 0:
			self.getGuideDetails()
		else:
			self.loopGuideDownloadAllDays()


	def canSkipByDB(self, entry):
		tstamp_start = self.unixtime(entry["datum"], entry["starttime"])
		tstamp_end = self.unixtime(entry["datum_end"], entry["endtime"])
		skytime = self.skyTimeStamp(entry["starttime"], tstamp_start, tstamp_end)
		#datum = getDateFromTimestamp(skytime[0])

		pk_event_arr = sql.existEvent_(entry["title"], entry["season_no"], entry["episode_no"], entry["id_channel"], skytime[0], skytime[1])
		if pk_event_arr:
			if entry["season_no"] >= 0:
				self.debug_print_log('Skip {} {} {} / S{}/E{}'.format(entry["datum"], entry["starttime"], entry["title"], entry["season_no"], entry["episode_no"]))
			else:
				self.debug_print_log('Skip {} {} {} / {}'.format(entry["datum"], entry["starttime"], entry["title"], entry["category"]))
			return True
		else:
			return False


	def canSkipByError500(self, entry):
		tstamp_start = self.unixtime(entry["datum"], entry["starttime"])
		tstamp_end = self.unixtime(entry["datum_end"], entry["endtime"])
		skytime = self.skyTimeStamp(entry["starttime"], tstamp_start, tstamp_end)
		#datum = getDateFromTimestamp(skytime[0])

		pk_eventerrors = sql.existEventDetailError(entry["title"], entry["season_no"], entry["episode_no"], entry["id_channel"], skytime[0], skytime[1])
		if pk_eventerrors:
			if entry["season_no"] >= 0:
				self.debug_print_log('Skip-500 {} {} {} / S{}/E{}'.format(entry["datum"], entry["starttime"], entry["title"], entry["season_no"], entry["episode_no"]))
			else:
				self.debug_print_log('Skip-500 {} {} {} / {}'.format(entry["datum"], entry["starttime"], entry["title"], entry["category"]))
			return True
		else:
			return False



	def getGuideDetails(self):
		max_idx = len(self.tv_guide_list) - 1
		ds = defer.DeferredSemaphore(tokens=1)
		for idx in range(len(self.tv_guide_list)):
			entry = self.tv_guide_list[idx]
			url = entry["details_url"]
			d = ds.run(self.guideDetailsDownload, url, entry).addCallback(self.guideDataDetails, idx, max_idx, url, entry)
			if idx == max_idx:
				d.addErrback(self.dataErrorDetails, "@ " + entry["title"], self.loopGuideDownloadAllDays, entry)
			else:
				d.addErrback(self.dataErrorDetails, "@ " + entry["title"], None, entry)


	def guideDetailsDownload(self, url_data, entry):

		# try to break, if we have to
		if not self.IS_RUNNING:
			return

		# late skip (additional broadcasts can cause this)
		if self.canSkipByDB(entry):
			self.statEventsSkippedLate += 1
			return

		if entry["season_no"] >= 0:
			self.debug_print_log('Lade {} {} {} / S{}/E{}'.format(entry["datum"], entry["starttime"], entry["title"], entry["season_no"], entry["episode_no"]))
		else:
			self.info_print_log('Lade {} {} {} / {}'.format(entry["datum"], entry["starttime"], entry["title"], entry["category"]))

		self.statEventsRequested += 1
		#self.debug_print_log("lade Broadcast Details {0}".format(url_data))
		udetails = url_data.split("/")

		url = "https://www.sky.de/sgtvg/service/getBroadcastDetail"
		datos = '{"ei":' + udetails[0] + ',"ci":' + udetails[1] + ',"sto":10}'
		try:
			return requestPage('POST', url, headers=self.headersJSON, timeout=30, data=datos)
		except:
			url = url.encode('utf-8')
			datos = datos.encode('utf-8')
			return getPage(url, headers=self.headersJSON, agent=self.agent, timeout=30, method=b'POST', postdata=datos)


	def dataErrorDetails(self, error, comment=None, callback=None, entry=None):
		try:
			err_msg = error.getErrorMessage()

			if entry and err_msg.startswith('500 '):
				self.storeError500(entry)

				if callback:  # and callable(callback):
					self.debug_print_log("Next day -> (dataErrorDetails)")
					callback()
			else:
				self.dataError(error, comment, callback)

		except Exception as e:
			self.error_print_log("Exception in dataErrorDetails: {}".format(e))


	def storeError500(self, entry):
		self.statErrors += 1
		tstamp_start = self.unixtime(entry["datum"], entry["starttime"])
		tstamp_end = self.unixtime(entry["datum_end"], entry["endtime"])
		skytime = self.skyTimeStamp(entry["starttime"], tstamp_start, tstamp_end)

		sql.addEventDetailError(entry["title"], entry["season_no"], entry["episode_no"], entry["id_channel"],
								skytime[0], skytime[1], entry["event_id"])
		if entry["season_no"] >= 0:
			self.debug_print_log('Store error 500 {} {} {} / S{}/E{}'.format(entry["datum"], entry["starttime"],
																			  entry["title"], entry["season_no"],
																			  entry["episode_no"]))
		else:
			self.debug_print_log('Store error 500 {} {} {} / {}'.format(entry["datum"], entry["starttime"],
																		 entry["title"], entry["category"]))


	def guideDataDetails(self, data, idx, max_idx, url, tv_guide_entry):
		try:
			# try to break, if we have to
			if not self.IS_RUNNING:
				return

			if data:
				# a robot does not sleep, but we do, sometimes
				if not idx % 20:
					time.sleep(1.0)
				elif not idx % 10:
					time.sleep(0.5)
				elif not idx % 3:
					time.sleep(0.3)
				else:
					time.sleep(0.1)

				#self.debug_print_log("got url {0} for idx {1}/{2}".format(url, idx + 1, max_idx + 1))

				# debug values from grid
				#self.debug_print_log('1111111111111111111111111111111111111111111111111111111111111111111111111111111')
				#for key in tv_guide_entry:
				#	value = tv_guide_entry[key]
				#	self.debug_print_log('{} = {}'.format(key, value))
				#self.debug_print_log('1111111111111111111111111111111111111111111111111111111111111111111111111111111')

				details = json.loads(data)

				# # if we have a status code, we got an error
				# status_code = details.get('status', 0)
				# if status_code != 0:
				# 	if status_code == 500:
				# 		self.storeError500(tv_guide_entry)
				# 	#else: 503 Service unavailable, ...
				#
				# 	# if this is the last detail, continue with next day (or end the loop)
				# 	if idx == max_idx:
				# 		self.debug_print_log("Next day -> (guideDataDetails)")
				# 		self.loopGuideDownloadAllDays()
				# 	return

				details = details["event"]

				my_db_dict = {}
				bid = details.get('bid', 0)
				if not bid or bid == 0:
					self.error_print_log("No bid found in details!")
					return
				my_db_dict["broadcast_id"] = bid

				my_db_dict["series_id"] = details.get('sid', 0)

				description = details.get('desc', "")
				description = decodeHtml(description).decode('utf-8')
				my_db_dict["description"] = description

				image = details.get('pu', "")
				if image and image != "":
					image = self.SKY_GO_BASE + image
					my_db_dict["image"] = image

				# get the special infos, such as id_hd or is serie
				if details.get('hd', False):
					my_db_dict["hd"] = 1

				#is_169 = 1  # no field: details['techIcons']['hd']
				#my_db_dict.update({"is_169": is_169})

				if details.get('isdd', False):
					my_db_dict["dolby"] = 1

				if details.get('hsa', False):
					my_db_dict["dualch"] = 1

				my_db_dict["is_series"] = 0
				if details.get('isss', False):
					my_db_dict["is_series"] = 1

				if my_db_dict["is_series"] == 1 and tv_guide_entry["id_genre"] == 49:
					tv_guide_entry["id_genre"] = 2  # change from "-" (Sonstige) to "Serie"

				#is_ut = 0
				#my_db_dict.update({"is_ut": is_ut})

				#is_last = 0
				#my_db_dict.update({"is_last": is_last})

				#is_3d = details['techIcons']['v3d'] or 0
				#is_3d = 0
				#my_db_dict.update({"is_3d": is_3d})

				#new fields
				country = details.get('cop', "")
				if country and country != "":
					my_db_dict["country"] = country

				year = details.get('yop', 0)
				if year and year != 0:
					my_db_dict["year"] = str(year)

				# merge data from grid with details
				tv_guide_entry.update(my_db_dict)

				# debug values merged with details
				#self.debug_print_log('2222222222222222222222222222222222222222222222222222222222222222222222222222222')
				#for key in tv_guide_entry:
				#	value = tv_guide_entry[key]
				#	self.debug_print_log('{} = {}'.format(key, value))
				#self.debug_print_log('2222222222222222222222222222222222222222222222222222222222222222222222222222222')

				try:
					del(my_db_dict)
				except Exception:
					pass

				# we are done? start database update for this entry
				self.addToDatabase(tv_guide_entry, idx, max_idx)

				# add additional broadcasts to database
				self.addAdditionalBroadcastsToDB(details, tv_guide_entry, idx, max_idx)

				try:
					del(tv_guide_entry)
				except Exception:
					pass

		except Exception as e:
			self.error_print_log("guideDataDetails: {0}".format(e))

		# if this is the last detail, continue with next day (or end the loop)
		if idx == max_idx:
			self.loopGuideDownloadAllDays()


	def addAdditionalBroadcastsToDB(self, details, tv_guide_entry, idx, max_idx):

		all_broadcasts = details.get('bc', None)
		if not all_broadcasts:
			return

		#[self.debug_print_log('**** tv_guide_entry: {}\t= {}'.format(p, tv_guide_entry[p])) for p in tv_guide_entry]

		# prepare parameters of all additional broadcasts
		prepared_additionals = []
		for broadcast in all_broadcasts:
			channel_name = broadcast.get('cn', None)  # channel name e.g. 'Warner TV Film' or 'Warner TV Film HD'
			ei = broadcast.get('ei', None)  # event id e.g. 121401756
			bsd = broadcast.get('bsd', None)  # broadcast start date e.g. '21.12.2021'
			t = broadcast.get('t', None)  # start and end time e.g. '23:40 - 01:55 Uhr'
			#self.debug_print_log('################# broadcast: cn={},\tei={}, bsd={}, t={}'.format(channel_name, ei, bsd, t))
			if not channel_name or not ei:
				continue
			id_channel = sql.getIdChannel(channel_name, stb=False)
			if not id_channel:
				continue
			additional = {'event_id': ei, 'id_channel': id_channel}
			if bsd and t:
				additional['datum'] = bsd
				additional['starttime'] = t[0:5]
				additional['endtime'] = t[8:13]
				if datetime.datetime.strptime(additional['endtime'], '%H:%M') >= datetime.datetime.strptime(additional['starttime'], '%H:%M'):
					additional['datum_end'] = bsd  # ends same day
				else:  # ends next day
					additional['datum_end'] = (datetime.datetime.strptime(bsd, '%d.%m.%Y') + datetime.timedelta(days=1)).strftime('%d.%m.%Y')
				prepared_additionals.append(additional)
			else:
				# Missing broadcast date and start/end. The entry for channel without "HD" has it!
				# Check for date, start and end in previously stored additionals with same event id (for other channel).
				for a in prepared_additionals:
					if a['event_id'] == additional['event_id']:
						additional['datum'] = a['datum']
						additional['datum_end'] = a['datum_end']
						additional['starttime'] = a['starttime']
						additional['endtime'] = a['endtime']
						prepared_additionals.append(additional)
						break
			#[self.debug_print_log('+++++++++ additional: {}\t= {}'.format(p, additional[p])) for p in additional]

		# store all prepared additional broadcasts to database
		activated_db_channel_ids = sql.getActiveChannel()
		#self.debug_print_log('>>> activated_db_channel_ids = {}'.format(activated_db_channel_ids))
		num_prepared = 0
		for prepared in prepared_additionals:
			num_prepared += 1
			if prepared['id_channel'] in activated_db_channel_ids:
				#self.debug_print_log('>>> store add. broadcast {}/{}: {}'.format(num_prepared, len(prepared_additionals), prepared))
				comment_additional = ' [add. broadcast {}/{}]'.format(num_prepared, len(prepared_additionals))
				tv_guide_entry.update(prepared)
				self.addToDatabase(tv_guide_entry, idx, max_idx, comment_additional)
			#else:
			#	self.debug_print_log('>>> skip add. broadcast {}/{}: {}'.format(num_prepared, len(prepared_additionals), prepared))


	# if want to update database after we got the whole guide data - it nor recommend
	def callDatabaseUpdate(self):
		idx = 0
		max_idx = len(self.tv_guide_list) - 1
		for entry in self.tv_guide_list:
			self.addToDatabase(entry, idx, max_idx)
			idx += 1
		self.IS_RUNNING = False
		self.checkDone("Datenbank aktualisiert", set_stamp = True)
		return
	
		
	def addToDatabase(self, entry, idx, max_idx, comment_additional=""):
		status = "False"  # defaults to False, to indicate its unadded in recordtimer
		try:
			sql.cur.execute('SELECT SQLITE_VERSION()')
		except Exception:
			#sys.exc_clear()
			try:
				sql.connect()
			except Exception:
				return
	
		self.debug_print_log("update database entry idx {0}/{1}{2}".format(idx + 1, max_idx + 1, comment_additional))
		
		try:
			pk_broadcast = sql.addBroadcast(entry["id_genre"], entry["broadcast_id"], entry["series_id"], entry["title"],
											entry["episode_title"],	entry["description"], entry["category"], entry["country"],
											entry["year"], entry["season_no"], entry["episode_no"], entry["image"],
											entry["status"], entry["new"], entry["hd"], entry["dolby"], entry["dualch"],
											entry["highlight"],	entry["live"])
		except Exception as e:
			self.error_print_log("sql.addBroadcast: {}".format(e))
			return


		# if the starttime is in the past, continue to then next event
		tstamp_start = self.unixtime(entry["datum"], entry["starttime"])
		tstamp_end = self.unixtime(entry["datum_end"], entry["endtime"])
		skytime = self.skyTimeStamp(entry["starttime"], tstamp_start, tstamp_end)
		if getCurrentTimestamp() > skytime[0] and entry["new"] != 1:   # need to add outdated is_new events, to match newer ones later
			self.debug_print_log("ignored entry idx {0}/{1}{2}, event is outdated".format(idx + 1, max_idx + 1, comment_additional))
			return
		
		#elif sql.checkAdded(entry["title"], entry["description"], entry["id_channel"], entry["id_genre"]):	
		#elif sql.checkAdded(entry["title"], entry["description"], entry["id_channel"], None):
			# let us ignore finished recordings - we do not want new braodcast dates fot those events
		#	self.addLog("[skyrecorder] ignored entry idx {0}/{1}, event is already in table added".format(idx + 1, max_idx + 1))
		#if sql.checkAdded(entry["title"], entry["category"], None, None, True):
		if sql.checkAdded_(pk_broadcast, True):
			self.debug_print_log("ignored entry idx {0}/{1}{2}, event is hidden".format(idx + 1, max_idx + 1, comment_additional))
			return
		
		datum = getDateFromTimestamp(skytime[0])
		dayname = getDayOfTheWeek(skytime[0], False)

		try:
			sql.addEvent2(pk_broadcast, entry["id_channel"], entry["event_id"], datum, skytime[0], skytime[1], dayname)
		except Exception as e:
			self.error_print_log("sql.addEvent2: {}".format(e))
			return


	def checkDone(self, msg_log="", set_stamp=True):
		# we are done
		# store our latest update timestamp for the wakeMeUp function
		try:
			if set_stamp:
				config.plugins.skyrecorder.lastchecked.value = getCurrentTimestamp()
				config.plugins.skyrecorder.lastchecked.save()
				configfile.save()

			# delete outdated entries we needed for events which were tagged "is_new" in the past
			n = sql.deleteEvents(getCurrentTimestamp())
			if n == 1:
				msg = "{0} Eintrag geloescht".format(n)
			else:
				msg = "{0} Eintraege geloescht".format(n)
			self.info_print_log(msg)
		except Exception as e:
			self.error_print_log("set lastchecked / delete outdated entries: {0}".format(e))

		self.info_print_log(msg_log)

		# TMDB autocheck
		try:
			if config.plugins.skyrecorder.autoupdate_tmdb and config.plugins.skyrecorder.autoupdate_tmdb.value:
				self.addLog("TMDB autocheck start")
				mInfo = SkyTheMovieDB(timeout=10)
				mInfo.RunAutoloadInfosTMDB()
				self.addLog("TMDB autocheck done")
		except Exception as e:
			self.error_print_log("TMDB autocheck: {0}".format(e))

		# if we want automatic recordtimerentries, we start here
		try:
			if config.plugins.skyrecorder.auto_recordtimer_entries and config.plugins.skyrecorder.auto_recordtimer_entries.value:
				time.sleep(1)
				SkyRunAutocheck(self.session, no_after_event=self.no_after_event)
		except Exception as e:
			self.error_print_log("automatic record timer: {0}".format(e))

		if self.NEW_CHANNELS and self.NEW_CHANNELS != "":
			self.info_print_log("Sender hinzugefügt. Bitte die Senderliste prüfen: {0}".format(self.NEW_CHANNELS))
		if self.CHANGED_CHANNELS and self.CHANGED_CHANNELS != "":
			self.info_print_log("Sender wurden umbenannt: {0}".format(self.CHANGED_CHANNELS))

		self.IS_RUNNING = False

		try:
			# delete outdated detail errors '500'
			olderThanYesterday = int(time.mktime((datetime.datetime.now()-datetime.timedelta(days=2)).timetuple()))
			outdated_500_deleted = sql.deleteDetailErrors(olderThanYesterday)
			# statistics
			self.debug_print_log(
				'Events checked: total={}, skipped={}, skipped_500={}, skipped_late={}, requested={}, errors={}  (outdated_500_deleted: {})'.format(
					self.statEventsTotal, self.statEventsSkipped, self.statEventsSkipped500, self.statEventsSkippedLate,
					self.statEventsRequested, self.statErrors, outdated_500_deleted))
		except Exception as e:
			#self.error_print_log("sql.deleteDetailErrors and statistics: {}".format(e))
			print("sql.deleteDetailErrors and statistics: {}".format(e))

		self.info_print_log("Done")
		return


	def dataError(self, error, comment=None, callback=None):
		self.statErrors += 1
		try:
			error = error.getErrorMessage()
		except:
			pass

		if not comment:
			comment = ""

		if config.plugins.skyrecorder.debug_output and config.plugins.skyrecorder.debug_output.value and callback:
			msg = "{0} {1} ->".format(error, comment)
		else:
			msg = "{0} {1}".format(error, comment)

		self.error_print_log(msg)

		if callback:  # and callable(callback):
			callback()


	def unixtime(self, datum, uhrzeit):
		(std,min) = uhrzeit.split(':')
		(day,month,year) = datum.split('.')
		#year = "20%s" % year
		#print((year, month, day, std, min))
		time_date = datetime.datetime(int(year), int(month), int(day), int(std), int(min))
		return int(time.mktime(time_date.timetuple()))


	def skyTimeStamp(self, uhrzeit, startstamp, endstamp):
		#(std,min) = uhrzeit.split(':')
		# fix endtime is in the past
		if endstamp < startstamp:
			endstamp += (3600 * 24)
		# get duration	
		#stampdiff = endstamp - startstamp
		# build real start and end timestamps
		#if int(std) < 6 and int(std) >= 0:
		#	startstamp += (3600 * 24)
		#	endstamp = startstamp + stampdiff
		return [startstamp, endstamp]
		

	# fix sky-guide-time, cause skydays starting at 06:00
	#def skyTimeStamp(self, uhrzeit, startstamp, endstamp):
	#	(std,min) = uhrzeit.split(':')
	#	# fix endtime is in the past
	#	if endstamp < startstamp:
	#		endstamp += (3600 * 24)
	#	# get duration	
	#	stampdiff = endstamp - startstamp
	#	# build real start and end timestamps
	#	if int(std) < 6 and int(std) >= 0:
	#		startstamp += (3600 * 24)
	#		endstamp = startstamp + stampdiff
	#	return [startstamp, endstamp]


	def addLog(self, text):
		if not isinstance(text, str):
			try:
				text = text.getErrorMessage()
			except:
				pass
				
		if len(text) < 1:
			return
		# check the current file size truncate the file if size is greater than defined limit 200 KB (204800 Bytes)
		sizeb = os.path.getsize(self.sky_log_path)
		if sizeb > 204800:
			# truncate only the first 100 lines in file - delete the oldest ones
			with open(self.sky_log_path, "r+") as f:
				for x in range(100):
					f.readline()
					f.truncate()

		lt = time.localtime()
		datum = time.strftime("%d.%m.%Y - %H:%M:%S", lt)
		with open(self.sky_log_path , "a") as write_log:
			write_log.write('"%s - %s"\n' % (datum, text))


	def print_and_log(self, text, prefix=None):
		if not text:
			return
		if prefix:
			msg = "[skyrecorder] {0}: {1}".format(prefix, text)
		else:
			msg = "[skyrecorder] {0}".format(text)
		print(msg)
		self.addLog(msg)

	def info_print_log(self, text):
		self.print_and_log(text)

	def warn_print_log(self, text):
		self.print_and_log(text, "WARNING")

	def error_print_log(self, text):
		self.print_and_log(text, "ERROR")

	def debug_print_log(self, text):
		try:
			is_debug = config.plugins.skyrecorder.debug_output and config.plugins.skyrecorder.debug_output.value
		except Exception:
			#sys.exc_clear()
			is_debug = True		# if setting is missing we show it all
		if is_debug:
			self.print_and_log(text)


	#def buildSkyChannelList(self,sky_channels):
	#	my_channel_dict = None
	#	my_channel_dict = {}
	#	for channel in sky_channels["channelList"]:
	# ?		my_channel_dict.update({int(channel["id"]):str(channel["name"])})
	# ?		my_channel_dict.update({int(channel["ci"]):str(channel["cn"])})
	#	return my_channel_dict 
		
	
	# Disabled because of New JSON-Query
	def getSkyStations(self):
		sky_stationIds= {
			1: 'Sky Krimi', 2: 'Sky Atlantic HD', 3: 'FOX Serie', 4: 'FOX HD', 5: 'TNT Serie',
			6: 'TNT Serie HD', 7: 'RTL Crime', 8: 'SYFY', 9: '13th Street', 10: 'RTL Living',
			11: 'RTL Passion', 12: 'AXN Action', 13: 'AXN HD', 14: 'ANIMAX', 15: 'Sat.1 Emotions',
			16: 'Romance TV', 17: 'Sky Sport News HD', 18: 'Sky Sport HD 1', 19: 'Sky Sport HD 2',
			20: 'Sky Sport HD Extra', 21: 'Sky Sport News', 22: 'Sky Bundesliga', 23: 'Sky Bundesliga 1',
			24: 'Sky Bundesliga 2', 25: 'Sky Bundesliga 3', 26: 'Sky Bundesliga 4', 27: 'Sky Bundesliga 5',
			28: 'Sky Bundesliga 6', 29: 'Sky Bundesliga 7', 30: 'Sky Bundesliga 8', 31: 'Sky Bundesliga 9',
			32: 'Sky Bundesliga 10', 33: 'Sky Bundesliga 11', 34: 'Sky Sport 1', 35: 'Sky Sport 2',
			36: 'Sky Sport 3', 37: 'Sky Sport 4', 38: 'Sky Sport 5', 39: 'Sky Sport 6', 40: 'Sky Sport 7',
			41: 'Sky Sport 8', 42: 'Sky Sport 9', 43: 'Sky Sport 10', 44: 'Sky Sport 11',
			45: 'Sky Sport 12', 46: 'Sky Sport 13', 47: 'Sky Sport Austria', 48: 'ESPN America (S)',
			49: 'ESPN America HD', 50: 'EuroSport 2 Deutschland', 51: 'Eurosport HD', 52: 'motorvision',
			53: 'Sport1+ HD', 54: 'Sky 3D', 55: 'Sky Cinema', 56: 'Sky Cinema HD', 57: 'Sky Cinema +1',
			58: 'Sky Cinema +24', 59: 'Sky Cinema Action', 60: 'Sky Cinema Action HD', 61: 'Sky Cinema Comedy', 62: 'Sky Cinema Emotion',
			63: 'Sky Cinema Nostalgie', 64: 'Sky Cinema Hits', 65: 'Sky Cinema Hits HD', 66: 'Disney Cinemagic',
			67: 'Disney Cinemagic HD', 68: 'MGM', 69: 'TNT Film', 70: 'Kinowelt TV', 71: 'kabel eins classics',
			72: 'Heimatkanal', 73: 'Beate-Uhse.TV', 80: 'National Geographic', 81: 'National Geographic HD',
			82: 'Discovery Channel', 83: 'Discovery Channel HD', 84: 'Spiegel Geschichte', 85: 'History Channel',
			86: 'History Channel HD', 87: 'National Geopgraphic Wild', 88: 'National Geopgraphic Wild HD',
			89: 'Biography Channel', 90: 'Disney Channel HD', 91: 'Disney Channel', 92: 'Disney Junior',
			93: 'Disney XD', 94: 'Boomerang', 95: 'Cartoon Network (S)', 96: 'Junior', 97: 'Nicktoons (S)',
			98: 'Goldstar TV', 99: 'Classica', 100: 'MTV Germany', 101: 'MTV Live HD', 102: 'Sky Select 1',
			103: 'Sky Select 2', 104: 'Sky Select 3', 105: 'Sky Select 4', 106: 'Sky Select 5',
			107: 'Sky Select 6', 108: 'Sky Select 7', 109: 'Sky Select 8', 110: 'Sky Select 9',
			111: 'Sky Select Event A', 112: 'Sky Select Event B', 113: 'Sky Select HD', 114: 'sportdigital',
			115: 'SYFY HD', 116: '13th Street HD', 160: 'MGM HD', 117: 'E! Entertainment HD'
			}
		
		return sky_stationIds

